--------------------------------------------------------------------------------
-- Weapon trempoline0 + Projectile trempoline0
-- Original Carnage Contest Weapon inspired
-- Script by Thecode,September 2010
--------------------------------------------------------------------------------

-- Setup Tables
if thecode==nil then thecode={} end
thecode.trempoline0={}
thecode.trempoline0.trempoline0={}

-- Load & Prepare Ressources
thecode.trempoline0.gfx_wpn=loadgfx("weapons/trempoline0.png")					-- Weapon Image
thecode.trempoline0.gfx_wpn1=loadgfx("weapons/trempoline1.png")	
setmidhandle(thecode.trempoline0.gfx_wpn)
thecode.trempoline0.sfx_attack=loadsfx("throw.ogg")							-- Attack Sound
thecode.trempoline0.sfx_bounce=loadsfx("bounce.wav")							-- Bounce Sound

--------------------------------------------------------------------------------
-- Weapon: trempoline0
--------------------------------------------------------------------------------

thecode.trempoline0.id=addweapon("thecode.trempoline0","trempoline0",thecode.trempoline0.gfx_wpn)	-- Add Weapon

function thecode.trempoline0.draw()											-- Draw
	if weapon_shots<=0 then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		drawinhand(thecode.trempoline0.gfx_wpn,6,0)
	end
	-- HUD chargebar
	if weapon_charge>0 and weapon_shots==0 then
		hudchargebar(weapon_charge,100)
	end
	
end

function thecode.trempoline0.attack(attack)									-- Attack
	if (weapon_shots<=0) then
		-- Charge
		if (attack==1) then
			weapon_charge=weapon_charge+1							-- Increase charge
		end
		-- Fire a projectile (on release/full charge)
		if (attack==0 and weapon_charge>0) or (weapon_charge>=100) then
			-- No more weapon switching!
			useweapon(1)
			playsound(thecode.trempoline0.sfx_attack)
			weapon_shots=weapon_shots+1
			id=createprojectile(thecode.trempoline0.trempoline0.id)
			projectiles[id]={}
			-- Ignore collision with current player at beginning
			projectiles[id].ignore=playercurrent()
			-- Set initial position of projectile
			projectiles[id].x=getplayerx(0)+(4*getplayerdirection(0))
			projectiles[id].y=getplayery(0)+3
			-- Initial collision check (avoid throwing into other objects)
			for i=0,10,1 do
				if collision(col5x5,projectiles[id].x+math.sin(math.rad(getplayerrotation(0)))*i,projectiles[id].y-math.cos(math.rad(getplayerrotation(0)))*i,1,1)==1 then
					if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
						if (i==0) then
							projectiles[id].x=getplayerx(0)
							projectiles[id].y=getplayery(0)+3
							break
						else
							projectiles[id].x=getplayerx(0)+(4*getplayerdirection(0))+math.sin(math.rad(getplayerrotation(0)))*(i-1)
							projectiles[id].y=getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*(i-1)
							break
						end
					end
				end
			end
			-- Set speed of projectile
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*(weapon_charge/100.0)*10.0
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*(weapon_charge/100.0)*10.0
			-- Set timer
			-- Set timer
			projectiles[id].timer=500
			-- Effects
			recoil(2)
			-- End Turn
			
		end
	end
end

--------------------------------------------------------------------------------
-- Projectile: trempoline0
--------------------------------------------------------------------------------

thecode.trempoline0.trempoline0.id=addprojectile("thecode.trempoline0.trempoline0")	-- Add Projectile

function thecode.trempoline0.trempoline0.draw(id)						-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(thecode.trempoline0.gfx_wpn,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function thecode.trempoline0.trempoline0.update(id)						-- Update
	-- Gravity influence on speed
	projectiles[id].sy=projectiles[id].sy+getgravity()
	
		-- Move X
		
		if collision(col5x5,projectiles[id].x,projectiles[id].y,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
				if (math.abs(projectiles[id].sx)>0.5) then playsound(thecode.trempoline0.sfx_bounce) end
			end
			if playercollision()~=0 then
			if projectiles[id].timer>=480 then
			
			else
			if getplayerdirection(0)==1 then
			playerpush(0,math.sin(math.rad(5))*37.0,-math.cos(math.rad(5))*17.0,1,0)
		elseif getplayerdirection(0)==-1 then
			playerpush(0,math.sin(math.rad(-5))*37.0,-math.cos(math.rad(5))*17.0,1,0)
			end
			end
			end
		else
			projectiles[id].ignore=0
		end
		-- Move Y
		
		if collision(col5x5,projectiles[id].x,projectiles[id].y,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
				if (math.abs(projectiles[id].sy)>0.5) then playsound(thecode.trempoline0.sfx_bounce) end
				
			end
			if playercollision()~=0 then
			if projectiles[id].timer>=480 then
			
			else
			if getplayerdirection(0)==1 then
			playerpush(0,math.sin(math.rad(5))*37.0,-math.cos(math.rad(5))*17.0,1,0)
		elseif getplayerdirection(0)==-1 then
			playerpush(0,math.sin(math.rad(-5))*37.0,-math.cos(math.rad(5))*17.0,1,0)
			end
			end
			end
		else
			projectiles[id].ignore=0
		end		
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			
		end
	
	-- Timer -> Explode
	projectiles[id].timer=projectiles[id].timer-1
	if projectiles[id].timer<=0 then
		-- Cause damage
		arealdamage(projectiles[id].x,projectiles[id].y,100,50)
		-- Destroy terrain
		terrainexplosion(projectiles[id].x,projectiles[id].y,30,1)
		-- Crater
		grey=math.random(0,40)
		if math.random(0,1)==1 then
			terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
		else
			terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
		end
		-- Free projectile
		freeprojectile(id)
	end
	
end